<TeXmacs|0.3.4.3>

<style|article>

<\body>
  <assign|code|<macro|body|<surround|<vspace*|1fn>|<vspace|1fn><format|no
  indentation after>|<with|font family|tt|language|verbatim|<arg|body>>>>><ap\
  ply|title|Syntax of the Mathemagix language><apply|author|Joris van der
  Hoeven><apply|address|Laboratoire de Mathmatiques (bt. 425)<format|next
  line>Universit Paris-Sud<format|next line>91405 Orsay Cedex<format|next
  line>France>

  <apply|maketitle>

  <\abstract>
    Below, we describe the syntax of the Mathemagix language. See
    <tt|src/parser/mm_parser.y> for the grammar file.
  </abstract>

  <section|Keywords and special symbols>

  <\description>
    <expand|item*|Main keywords.><vspace|0.5fn>

    <format|no first indentation><with|font family|tt|add, as, break, case,
    catch, continue, do, else, extend, for, from, generate, has, hidden,
    holds, if, in, import, inherit, raise, return, step, then, try, until,
    value, while, with, yield, ==\<gtr\>>

    <expand|item*|Export modifiers.><vspace|0.5fn>

    <format|no first indentation><with|font family|tt|abstract, concrete,
    constant, direct, evolutive, extern, indirect, inline, intern, locked,
    method, private, protected, outline, packed, public, unpacked, variable>

    <expand|item*|Mathematical symbols.>

    <\code>
      == \ \ := \ \ += \ \ -= \ \ *= \ \ /=

      : \ \ \ ::

      -\<gtr\> \ \ :-\<gtr\>

      \<less\>\<less\> \ \ \<gtr\>\<gtr\>

      or \ \ \|\| \ \ ^^

      and \ &&

      !

      =\<gtr\> \ \ \<less\>=\<gtr\>

      = \ \ \ \<less\> \ \ \ \<less\>= \ \ \<gtr\> \ \ \ \<gtr\>= \ \ !=
      \ \ !\<less\> \ \ !\<less\>= \ !\<gtr\> \ \ !\<gtr\>=

      :\<gtr\> \ \ ::\<gtr\>

      ..

      + \ \ \ - \ \ \ @+ \ \ @-

      * \ \ \ / \ \ \ @* \ \ @/ \ \ @ \ \ \ div \ mod

      ` '

      ^

      ++ \ \ ---

      ! \ \ \ ' \ \ \ #

      . \ \ \ () \ \ []
    </code>

    Here <with|font family|tt|\|\|>, <with|font family|tt|^^>, <with|font
    family|tt|&&> and <with|font family|tt|!> stand for bitwise <with|font
    family|tt|or>, <with|font family|tt|xor>, <with|font family|tt|and> and
    <with|font family|tt|not>. The operators <with|font family|tt|@+, @-, @*,
    @/> and <with|font family|tt|@> respectively stand for
    <with|mode|math|\<oplus\>>, <with|mode|math|\<ominus\>>,
    <with|mode|math|\<otimes\>>, <with|mode|math|\<oslash\>> and
    <with|mode|math|\<circ\>>. Finally, <with|font family|tt|` <format|no
    line break>'> denotes nothing or a blank space and <with|font
    family|tt|()> and <with|font family|tt|[]> respectively denote function
    application and data access.
  </description>

  \;
</body>

<\initial>
  <\collection>
    <associate|odd page margin|30mm>
    <associate|paragraph width|150mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|paragraph hyphenation|professional>
    <associate|reduction page bottom margin|15mm>
    <associate|page type|a4>
    <associate|reduction page left margin|25mm>
    <associate|even page margin|30mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|cond-exports|4.5>
    <associate|rem-spec|6.1>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate>
      toc
    <|associate>
      <vspace*|1fn><with|font series|<quote|bold>|1 Keywords and special
      symbols><htab|5mm>?<vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>
